rle:
    moveq       #20,d3	;20 for 89

;----decompress picture to video memory----

    move.w  #1999,d0        ;decompress 2000 bytes, 1999
    ;128 x (240/8) = 128 x 30 = 3840, -1 = 3839
rle_loop:
    move.b  (a0)+,d1        ;get next byte
    cmp.b       #$91,d1     ;is it a run?
    beq.s       decode_run      ;then decode the run
    move.b  d1,(a1)+        ;else store it to video memory
    bsr.s       check_line_end
continue_rle:
    dbra        d0,rle_loop
    rts
decode_run:
    move.b  (a0)+,d1        ;get byte to repeat
    move.b  (a0)+,d2        ;get how many time to repeat
continue_run:
    move.b  d1,(a1)+        ;move it
    bsr.s       check_line_end
    subq.b  #1,d2
    dbeq        d0,continue_run ;go until the run is done or number of bytes is done
    beq.s       continue_rle    ;see if it was the run that was done or the number
                        ;  of bytes to decompress to.  If it was the run that
                        ;  ended then the last execution of the dbeq did not
                        ;  not decrement d0, but it still needs to be
                        ;  decrimented.
    rts




check_line_end:
    subq.w  #1,d3
    bne.s       stay_on_line
    moveq       #20,d3
    lea     10(a1),a1

stay_on_line:
    rts

 include "picdata_89.asm"