;The original code came from the xmas file ticalc.org/pub/92plus/asm/graphics
;My goal is to make it nostub and under 8K. So far so good...

;History & Notes
;****************************************************
;9-24-03 -- Obtained this from ticalc.org
;9-26-03 -- Success in making a ClrScr routine
;	    and making a picture work in 4 greys
;	    and 7 greys under AMS 2.05. Only the 1st
;	    and last planes needed to be switched
;	    for it to work properly on both 4 & 7.
;	 -- New idea before taking out graphlib.
;	    userlib was never needed. Add RLE support
;	    and load each plane from the result.
;7 Greys -- A TI-92+ version can't be nostub unless
;	    the picture is crappy. A TI-89 small
;	    enough screen for a nostub version.
;4 Greys -- A TI-92+ version can be nostub but must
;	    have good compression. A TI-89 small
;	    enough screen for a nostub version.
;	 -- Black & White version has been done since
;	    9-22-03 and supports RLE compressed data.
;	    Both the TI-89 and 92+ b/w are nostub.
;****************************************************

	include	graphlib.h
	include	os.h
	include	picdata_89.asm
	xdef	_main
;	xdef	_ti92plus
	xdef	_ti89

Save_Restore:
    	movem.l d3-d7/a2-a6,-(sp)
    	lea -3840(sp),sp
    	pea 3840
	pea $4C00
	pea 8(sp)
    	move.l  $C8,a0
    	move.l  4*memcpy(a0),a2
    	jsr (a2)
    	jsr _main
    	pea 3840
    	pea 16(sp)
    	pea $4C00
    	move.l $C8,a0
    	move.l  4*memcpy(a0),a2
    	jsr (a2)
    	lea 3864(sp),sp
    	movem.l (sp)+,d3-d7/a2-a6
    	rts

_main:
	move.w 	#5,d4
	jsr	graphlib::gray4
	move.w	#1,graphlib::choosescreen
	move.l	graphlib::plane0,a1

;William White's ClrScr Routine
    	movem.l d3-d7/a2-a6,-(sp)
 	move.l $C8,a5          		;Load the AMS_jumptable
 	move.l 4*ClrScr(a5),a4     	;Load the ClrScr function into a4
 	jsr (a4)           		;Execute the ClrScr function from a4
    	movem.l (sp)+,d3-d7/a2-a6

	move.w	#0,d0
	move.w	#0,d1

	move.l	graphlib::plane0,a1
	lea	plane2(PC),a0
	jsr	graphlib::put_sprite

	move.l	graphlib::plane1,a1
	lea	plane1(PC),a0
	jsr	graphlib::put_sprite

;William White's Pause Routine
  	movem.l d3-d7/a2-a6,-(sp)
    	move.l $C8,a5
    	move.l 4*ngetchx(a5),a4
    	jsr     (a4)
    	movem.l (sp)+,d3-d7/a2-a6

	clr.w	graphlib::choosescreen
	jsr	graphlib::gray2
	rts

	end